package com.laihua.projecthelper

import java.io.File
import java.io.FileReader
import java.util.ArrayList

/**
 * Author: pengjunjing
 * Date: 2022/3/4
 * Description:解析
 */
class ParseUtil {

    /**
     * 返回引用了图片资源的该行文本内容
     */
    fun parseFile(file: File): MutableList<String> {
        val reader = FileReader(file)
        val readLines = reader.readLines()
        val result = mutableListOf<String>()
        for (readLine in readLines) {
            //判断该行是否引用了图片资源
            if (readLine.contains("@drawable") //xml引用
                || readLine.contains("@mipmap")
                || readLine.contains("R.drawable")//java kt代码引用
                || readLine.contains("R.mipmap")
                || readLine.contains("R.raw")
                || readLine.contains("R.layout")//布局文件
                || readLine.contains("@layout")
                || readLine.contains("@color")
            ) {
                result.add(readLine)
            }
        }
        return result

    }

    /**
     * 开始解析未使用的资源文件
     */
    fun startParseUnused(readImageRes: List<File>, readCodeFile: List<File>): MutableSet<File> {
        val fileNames = Array<String>(readImageRes.size) {
            //文件名 ,带后缀,去除后缀
            val name = readImageRes[it].name
            if (name.contains(".")) {
                name.substring(0, name.indexOf("."))
            } else {
                name
            }
        }

        val use = mutableListOf<String>()
        val useSet = mutableSetOf<File>()



        readCodeFile.forEach { file ->
            val parseFileLines = parseFile(file)
            if (parseFileLines.isNotEmpty()) {
                //有包含资源的代码行
                outFor@ for (i in fileNames.indices) {
                    inFor@ for (parseFileLine: String in parseFileLines) {
                        if (parseFileLine.contains(fileNames[i])) {
                            //有在使用该资源
                            use.add(fileNames[i])
                            useSet.add(readImageRes[i])
                            continue@inFor
                        }
                    }
                }

            }
        }

        val unusedSet = mutableSetOf<File>()
        unusedSet.addAll(readImageRes)
        unusedSet.removeAll(useSet)
        return unusedSet

    }
}