package com.laihua.projecthelper

import java.io.File

/**
 * 未使用资源删除工具
 */
fun main(args: Array<String>) {
    println("开始读取文件")
    val projectRoot = File("")
    val projectRootF = File(projectRoot.absolutePath)

    println(projectRoot.absolutePath)
    //要检查资源的目录
    val baseFile = File("${projectRoot.absolutePath}${File.separator}laihuaBase${File.separator}src${File.separator}")
    //从项目根目录开始查找
//    val baseFile = File("${projectRoot.absolutePath}")
    println(baseFile.absolutePath + "\n")
    val readImageRes = ReadUtil().readImageRes(baseFile)
    val readCodeFile = ReadUtil().readCodeFile(projectRootF)

    val lengthMb = calcSize(readCodeFile)
    val lengthMbRes = calcSize(readImageRes)


    println("读取到图片资源数量:${readImageRes.size},占用空间:${lengthMbRes}")
    println("读取到代码资源数量:${readCodeFile.size},占用空间:${lengthMb}")

    val unusedSet = ParseUtil().startParseUnused(readImageRes, readCodeFile)
    val unusedSetMbRes = calcSize(readImageRes)
    println("未使用的资源总数:   ${unusedSet.size}  占用空间:${unusedSetMbRes}")
    unusedSet.forEach {
        println("未使用的资源:   ${it.name}")
        //确认要删除资源打开下一行代码,注释掉避免误删除
//        it.deleteOnExit()
    }

    //检查没使用的图片xml/布局xml文件
    val readImageXml = ReadUtil().readXmlFile(baseFile)
    val startParseUnused = ParseUtil().startParseUnused(readImageXml, readCodeFile)
    println("未使用的xml资源总数:   ${startParseUnused.size}")
    startParseUnused.forEach {
        println("未使用的xml资源:   ${it.absolutePath}")
        //确认要删除资源打开下一行代码,注释掉避免误删除
//        it.deleteOnExit()
    }

}

private fun calcSize(readCodeFile: MutableList<File>): Float {
    var totalLength = 0L
    for (file in readCodeFile) {
        totalLength += file.length()
    }
    return totalLength / 1024.0f / 1024
}

